--
-- Patch DDL de GRHUM du DD/MM/2012 à exécuter depuis le user GRHUM
--
-- Rem : fichier encodé UTF-8

SET DEFINE OFF;

--
--
-- Fichier : 2
-- Type : DML
-- Schema : GRHUM
-- Numero de version : 1.7.1.10
-- Date de publication : 06/06/2012
-- Auteur(s) : Cocktail
-- Licence : CeCILL version 2
-- Pré-requis : user CSE existant
--
--

WHENEVER SQLERROR EXIT SQL.SQLCODE;


--
-- DB_VERSION
--
-- pré-requis
declare
cpt integer;
version grhum.db_version.dbv_libelle%type;
begin
    select count(*) into cpt from grhum.db_version where dbv_libelle='1.7.1.9';
    if cpt = 0 then
        raise_application_error(-20000,'Le user GRHUM n''est pas à jour pour passer ce patch !');
    end if;
    select max(dbv_libelle) into version from grhum.db_version;
    if version = '1.7.1.10' then
        raise_application_error(-20000,'Le nouveau patch du user GRHUM est déjà appliqué.');
    end if;    
end;
/

/*
--
-- TYPE_UNITE_FINANCEMENT
--
CREATE TABLE GRHUM.TYPE_UNITE_FINANCEMENT
(
  ID_TUF  				NUMBER(2)	 			NOT NULL ,
  C_TUF    				VARCHAR2(20)  ,
  LC_TUF   				VARCHAR2(20) ,
  LL_TUF   				VARCHAR2(60) ,
  D_CREATION 			DATE DEFAULT SYSDATE 	NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE 	NOT NULL ,
  PERS_ID_CREATION  	NUMBER 	 				NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER
);

ALTER TABLE GRHUM.TYPE_UNITE_FINANCEMENT ADD CONSTRAINT PK_TYPE_UNITE_FINANCEMENT PRIMARY KEY(ID_TUF);
ALTER TABLE GRHUM.TYPE_UNITE_FINANCEMENT ADD CONSTRAINT UK_TYPE_UNITE_FINANCEMENT UNIQUE (C_TUF);
ALTER TABLE GRHUM.TYPE_UNITE_FINANCEMENT ADD CONSTRAINT FK_TUF_PERS_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRHUM.TYPE_UNITE_FINANCEMENT ADD CONSTRAINT FK_TUF_PERS_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE SEQUENCE GRHUM.TYPE_UNITE_FINANCEMENT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRHUM.TYPE_UNITE_FINANCEMENT IS 'Nomenclature des unités de financement';    
COMMENT ON COLUMN GRHUM.TYPE_UNITE_FINANCEMENT.ID_TUF IS 'Clef primaire de la table TYPE_UNITE_FINANCEMENT';
COMMENT ON COLUMN GRHUM.TYPE_UNITE_FINANCEMENT.C_TUF IS 'Code de l''unité de temps';
COMMENT ON COLUMN GRHUM.TYPE_UNITE_FINANCEMENT.LC_TUF IS 'Libellé court de l''unité de temps';
COMMENT ON COLUMN GRHUM.TYPE_UNITE_FINANCEMENT.LL_TUF IS 'Libellé long de l''unité de temps';
COMMENT ON COLUMN GRHUM.TYPE_UNITE_FINANCEMENT.D_CREATION IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN GRHUM.TYPE_UNITE_FINANCEMENT.D_MODIFICATION IS 'Date de modification de l''enregistrement';
COMMENT ON COLUMN GRHUM.TYPE_UNITE_FINANCEMENT.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRHUM.TYPE_UNITE_FINANCEMENT.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';





--
-- TYPE_FINANCEMENT
--
CREATE TABLE GRHUM.TYPE_FINANCEMENT
(
  ID_TYPE_FINANCEMENT  				NUMBER(2)	 			NOT NULL ,
  C_TYPE_FINANCEMENT    VARCHAR2(20)  ,
  LC_TYPE_FINANCEMENT   VARCHAR2(20) ,
  LL_TYPE_FINANCEMENT   VARCHAR2(60) ,
  D_CREATION 			DATE DEFAULT SYSDATE 	NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE 	NOT NULL ,
  PERS_ID_CREATION  	NUMBER 	 				NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER  
);


ALTER TABLE GRHUM.TYPE_FINANCEMENT ADD CONSTRAINT PK_TYPE_FINANCEMENT PRIMARY KEY(ID_TYPE_FINANCEMENT);
ALTER TABLE GRHUM.TYPE_FINANCEMENT ADD CONSTRAINT UK_TYPE_FINANCEMENT UNIQUE (C_TYPE_FINANCEMENT);
ALTER TABLE GRHUM.TYPE_FINANCEMENT ADD CONSTRAINT FK_TF_PERS_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRHUM.TYPE_FINANCEMENT ADD CONSTRAINT FK_TF_PERS_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE SEQUENCE GRHUM.TYPE_FINANCEMENT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRHUM.TYPE_FINANCEMENT IS 'Nomenclature des financements possibles.';    
COMMENT ON COLUMN GRHUM.TYPE_FINANCEMENT.ID_TYPE_FINANCEMENT IS 'Clef primaire de la table TYPE_FINANCEMENT';
COMMENT ON COLUMN GRHUM.TYPE_FINANCEMENT.C_TYPE_FINANCEMENT IS 'Code du financement';
COMMENT ON COLUMN GRHUM.TYPE_FINANCEMENT.LC_TYPE_FINANCEMENT IS 'Libellé court du financement';
COMMENT ON COLUMN GRHUM.TYPE_FINANCEMENT.LL_TYPE_FINANCEMENT IS 'Libellé long du financement';
COMMENT ON COLUMN GRHUM.TYPE_FINANCEMENT.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRHUM.TYPE_FINANCEMENT.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN GRHUM.TYPE_FINANCEMENT.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRHUM.TYPE_FINANCEMENT.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';

*/

--
-- TYPE_MOTIF
--
CREATE TABLE GRHUM.TYPE_MOTIF
(
  ID_TYPE_MOTIF 				NUMBER(2) 		NOT NULL  ,
  C_TYPE_MOTIF		    VARCHAR2(20) ,
  LC_TYPE_MOTIF   		VARCHAR2(20) ,
  LL_TYPE_MOTIF   		VARCHAR2(60) ,
  D_CREATION 			DATE DEFAULT SYSDATE 	NOT NULL ,
  D_MODIFICATION 		DATE DEFAULT SYSDATE 	NOT NULL ,
  PERS_ID_CREATION  	NUMBER 	 				NOT NULL ,
  PERS_ID_MODIFICATION 	NUMBER
);


ALTER TABLE GRHUM.TYPE_MOTIF ADD CONSTRAINT PK_TYPE_MOTIF PRIMARY KEY(ID_TYPE_MOTIF);
ALTER TABLE GRHUM.TYPE_MOTIF ADD CONSTRAINT UK_TYPE_MOTIF UNIQUE (C_TYPE_MOTIF);
ALTER TABLE GRHUM.TYPE_MOTIF ADD CONSTRAINT FK_TM_PERS_CREATION FOREIGN KEY (PERS_ID_CREATION) REFERENCES GRHUM.PERSONNE (PERS_ID);
ALTER TABLE GRHUM.TYPE_MOTIF ADD CONSTRAINT FK_TM_PERS_MODIFICATION FOREIGN KEY (PERS_ID_MODIFICATION) REFERENCES GRHUM.PERSONNE (PERS_ID);

CREATE SEQUENCE GRHUM.TYPE_MOTIF_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE NOORDER;

COMMENT ON TABLE GRHUM.TYPE_MOTIF IS 'Nomenclature des motifs possibles.';    
COMMENT ON COLUMN GRHUM.TYPE_MOTIF.ID_TYPE_MOTIF IS 'Clef primaire de la table TYPE_MOTIF';
COMMENT ON COLUMN GRHUM.TYPE_MOTIF.C_TYPE_MOTIF IS 'Code du motif';
COMMENT ON COLUMN GRHUM.TYPE_MOTIF.LC_TYPE_MOTIF IS 'Libellé court du motif';
COMMENT ON COLUMN GRHUM.TYPE_MOTIF.LL_TYPE_MOTIF IS 'Libellé long du motif';
COMMENT ON COLUMN GRHUM.TYPE_MOTIF.D_CREATION IS 'Date de création de l''enregistrement.';
COMMENT ON COLUMN GRHUM.TYPE_MOTIF.D_MODIFICATION IS 'Date de modification de l''enregistrement.';
COMMENT ON COLUMN GRHUM.TYPE_MOTIF.PERS_ID_CREATION IS 'pers_id de la personne à l''origine de la création de l''enregistrement';
COMMENT ON COLUMN GRHUM.TYPE_MOTIF.PERS_ID_MODIFICATION IS 'pers_id de la personne à l''origine de la modification de l''enregistrement';

  
--
-- TYPE_DECHARGE_SERVICE
--
ALTER TABLE GRHUM.TYPE_DECHARGE_SERVICE ADD TEM_NON_FONCTIONNAIRE VARCHAR2(1 ) DEFAULT 'O' NOT NULL;
ALTER TABLE GRHUM.TYPE_DECHARGE_SERVICE ADD CONSTRAINT CHK_TDS_TEM_NON_FONCT CHECK (TEM_NON_FONCTIONNAIRE IN ('O', 'N') );
COMMENT ON COLUMN GRHUM.TYPE_DECHARGE_SERVICE.TEM_NON_FONCTIONNAIRE IS 'Témoin indiquant si la décharge concerne les non fonctionnaires';



--
-- TYPE_CONTRAT_TRAVAIL
--
ALTER TABLE GRHUM.TYPE_CONTRAT_TRAVAIL ADD TEM_DROIT_HCOMP VARCHAR2(1) DEFAULT 'O' NOT NULL;
ALTER TABLE GRHUM.TYPE_CONTRAT_TRAVAIL ADD CONSTRAINT CHK_TCT_TEM_DROIT_HCOMP CHECK (TEM_DROIT_HCOMP IN ('O', 'N') );
COMMENT ON COLUMN GRHUM.TYPE_CONTRAT_TRAVAIL.TEM_DROIT_HCOMP IS 'Témoin précisant si les heures complémentaires sont autorisées pour ce type de contrat.';

COMMIT;
